/**
 * 
 */

#include <pp/base.h>
#include <pp/bmc/tp_i2c_chip.h>

typedef struct {
    /* chip superobject */
    pp_tp_i2c_chip_t base;
} pp_tp_blackford_mch_chip_t;


/* ppdoc
 * name:   BLACKFORD_MCH chip
 * tpname: BLACKFORD_MCH_chip
 * desc:   BLACKFORD_MCH chip object, needed by BLACKFORD_MCH sensors.
 * arg 0:  [OBJ(I2C_COM_DEV)] i2cdev: i2c device to be used
 * arg 1:  [INT] i2c_addr:            i2c slave address of this device
 * arg 2:  [OBJ(COND)] powercond:     power on condition (chip will be
 * arg 2:                             initialized if condition changes to on,
 * arg 2:                             sensors won't be read while cond is false)
 * return: [OBJ(I2C_CHIP)]
 */
pp_tp_obj_t* pp_blackford_mch_chip_ctor(const char* id, vector_t* args);

